/*
 * Copyright © 2018 Red Hat, Inc
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Matthias Clasen <mclasen@redhat.com>
 */

#if !defined(__KAIMING_H_INSIDE__) && !defined(KAIMING_COMPILATION)
#error "Only <kaiming.h> can be included directly."
#endif

#ifndef __KAIMING_INSTANCE_H__
#define __KAIMING_INSTANCE_H__

typedef struct _KaimingInstance KaimingInstance;

#include <glib-object.h>

G_BEGIN_DECLS

#define KAIMING_TYPE_INSTANCE kaiming_instance_get_type ()
#define KAIMING_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KAIMING_TYPE_INSTANCE, KaimingInstance))
#define KAIMING_IS_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KAIMING_TYPE_INSTANCE))

KAIMING_EXTERN GType kaiming_instance_get_type (void);

struct _KaimingInstance
{
  GObject parent;
};

typedef struct
{
  GObjectClass parent_class;
} KaimingInstanceClass;


#ifdef G_DEFINE_AUTOPTR_CLEANUP_FUNC
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KaimingInstance, g_object_unref)
#endif

KAIMING_EXTERN GPtrArray *  kaiming_instance_get_all (void);

KAIMING_EXTERN const char * kaiming_instance_get_id (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_app (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_arch (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_branch (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_commit (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_runtime (KaimingInstance *self);
KAIMING_EXTERN const char * kaiming_instance_get_runtime_commit (KaimingInstance *self);
KAIMING_EXTERN int          kaiming_instance_get_pid (KaimingInstance *self);
KAIMING_EXTERN int          kaiming_instance_get_child_pid (KaimingInstance *self);
KAIMING_EXTERN GKeyFile *   kaiming_instance_get_info (KaimingInstance *self);

KAIMING_EXTERN gboolean     kaiming_instance_is_running (KaimingInstance *self);

G_END_DECLS

#endif /* __KAIMING_INSTANCE_H__ */
