/*
 * Copyright © 2015 Red Hat, Inc
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Alexander Larsson <alexl@redhat.com>
 */

#if !defined(__KAIMING_H_INSIDE__) && !defined(KAIMING_COMPILATION)
#error "Only <kaiming.h> can be included directly."
#endif

#ifndef __KAIMING_RELATED_REF_H__
#define __KAIMING_RELATED_REF_H__

typedef struct _KaimingRelatedRef KaimingRelatedRef;

#include <gio/gio.h>
#include <kaiming-ref.h>

G_BEGIN_DECLS

#define KAIMING_TYPE_RELATED_REF kaiming_related_ref_get_type ()
#define KAIMING_RELATED_REF(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), KAIMING_TYPE_RELATED_REF, KaimingRelatedRef))
#define KAIMING_IS_RELATED_REF(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), KAIMING_TYPE_RELATED_REF))

KAIMING_EXTERN GType kaiming_related_ref_get_type (void);

struct _KaimingRelatedRef
{
  KaimingRef parent;
};

typedef struct
{
  KaimingRefClass parent_class;
} KaimingRelatedRefClass;

#ifdef G_DEFINE_AUTOPTR_CLEANUP_FUNC
G_DEFINE_AUTOPTR_CLEANUP_FUNC (KaimingRelatedRef, g_object_unref)
#endif

KAIMING_EXTERN const char * const *kaiming_related_ref_get_subpaths (KaimingRelatedRef * self);
KAIMING_EXTERN gboolean     kaiming_related_ref_should_download (KaimingRelatedRef *self);
KAIMING_EXTERN gboolean     kaiming_related_ref_should_delete (KaimingRelatedRef *self);
KAIMING_EXTERN gboolean     kaiming_related_ref_should_autoprune (KaimingRelatedRef *self);

G_END_DECLS

#endif /* __KAIMING_RELATED_REF_H__ */
