/*
 * Copyright © 2015 Red Hat, Inc
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Alexander Larsson <alexl@redhat.com>
 */

#if !defined (__KAIMING_H_INSIDE__) && !defined (KAIMING_COMPILATION)
#error "Only <kaiming.h> can be included directly."
#endif

#ifndef __KAIMING_VERSION_MACROS_H__
#define __KAIMING_VERSION_MACROS_H__


/**
 * KAIMING_MAJOR_VERSION:
 *
 * The major version.
 */
#define KAIMING_MAJOR_VERSION (1)

/**
 * KAIMING_MINOR_VERSION:
 *
 * The minor version.
 */
#define KAIMING_MINOR_VERSION (14)

/**
 * KAIMING_MICRO_VERSION:
 *
 * The micro version.
 */
#define KAIMING_MICRO_VERSION (2)

/**
 * KAIMING_CHECK_VERSION:
 * @major: major version to compare against
 * @minor: minor version to compare against
 * @micro: micro version to compare against
 *
 * Check that the current version is at least @major.@minor.@micro.
 */
#define KAIMING_CHECK_VERSION(major,minor,micro)        \
    (KAIMING_MAJOR_VERSION > (major) || \
     (KAIMING_MAJOR_VERSION == (major) && KAIMING_MINOR_VERSION > (minor)) || \
     (KAIMING_MAJOR_VERSION == (major) && KAIMING_MINOR_VERSION == (minor) && \
      KAIMING_MICRO_VERSION >= (micro)))

#ifndef KAIMING_EXTERN
#define KAIMING_EXTERN extern
#endif

/**
 * SECTION:kaiming-version-macros
 * @Title: Version information
 *
 * These macros can be used to check the library version in use.
 */

#endif /* __KAIMING_VERSION_MACROS_H__ */
